<template>
    <scTable ref="table" :apiObj="list.apiObj" :params="searchKey" @selectionChange="selectionChange" row-key="id" border>
        <el-table-column type="selection" width="50" fixed="left"></el-table-column>
        <el-table-column label="订单编号" width="150" fixed="left" prop="name">
            <template #default="scope">
                {{scope.row.order_id?scope.row.order_id:'-'}}
            </template>
        </el-table-column>
        <el-table-column label="地址ID" width="150" prop="factory_id"></el-table-column>
        <el-table-column label="所属代理" width="150" prop="agent_id"></el-table-column>
        <el-table-column label="联系人" prop="login_at" width="180">
            <template #default="scope">
                {{scope.row.contact_name?scope.row.contact_name:'-'}}
            </template>
        </el-table-column>
        <el-table-column label="联系电话" prop="login_at" width="180">
            <template #default="scope">
                {{scope.row.contact_mobile?scope.row.contact_mobile:'-'}}
            </template>
        </el-table-column>
        <el-table-column label="详细地址" prop="login_at" width="280">
            <template #default="scope">
                {{scope.row.address?scope.row.address:'-'}}
            </template>
        </el-table-column>
        <el-table-column label="注册来源" prop="login_at" width="120">
            <template #default="scope">
                <div class="status-success" v-if="scope.row.source==1">代理</div>
                <div class="status-danger" v-else>门店</div>
            </template>
        </el-table-column>
        <el-table-column label="登录账号" prop="truename" width="150">
            <template #default="scope">
                <span v-if="scope.row.username">{{ scope.row.username }}</span>
                <span class="status-danger" v-else>未设置</span>
            </template>
        </el-table-column>
        <el-table-column label="创建时间" prop="create_at" width="180"></el-table-column>
        <el-table-column label="状态" prop="status" width="120" align="center">
            <template #default="scope">
                <el-popconfirm title="确定要启用或冻结该账号吗？" @confirm="table_state(scope.row)">
                    <template #reference>
                        <div class="status-success" v-if="scope.row.status==1"><sc-status-indicator type="success"></sc-status-indicator> 正常</div>
                        <div class="status-danger" v-else><sc-status-indicator type="danger"></sc-status-indicator> 禁用</div>
                    </template>
                </el-popconfirm>
            </template>
        </el-table-column>
        <el-table-column label="操作" width="200" align="right" fixed="right">
            <template #default="scope">
                <el-button-group>
                    <el-button text size="small" @click="table_user(scope.row)">用户管理</el-button>
                    <el-button text type="warning" size="small" @click="table_passwd(scope.row)">编辑</el-button>
                    <el-popconfirm title="确定删除吗？" @confirm="table_del(scope.row, scope.$index)">
                        <template #reference>
                            <el-button text type="danger" size="small">删除</el-button>
                        </template>
                    </el-popconfirm>                    
                </el-button-group>
            </template>
        </el-table-column>
    </scTable>
</template>

<script>
export default {
    data(){
        return {
            list: {
                apiObj: this.$API.order.list
            },
            dataSelect:[],
            dataSelectFull:[],
            searchKey:{"type":this.type}
        }
    },
    methods: {
        table_user(row){
            this.$nextTick(() => {
                this.$refs.userMain.open("edit").setData(row)
            })
        },
        refresh(){
            this.$refs.table.refresh()
        },
        upData(data){
            this.$refs.table.upData(data)
        },
        handleSuccess(){
            this.$refs.table.refresh()
        },
        sortChange(event){
            if (event.order) {
                var data = {
                    "field":event.prop,
                    "order":event.order
                }
                this.$refs.table.upData(data)
            } else {
                this.$refs.table.reload(this.searchKey)
            }
            return ;
        },
        selectionChange(event){
            this.dataSelect = [];
            var arr = [];
            var arrCompany = [];
            event.forEach(function(val,index){
                arr[index] = val.id;
                arrCompany[index] = val;
            });
            this.dataSelectFull = arrCompany;
            this.dataSelect = arr;
            this.$emit("success",this.dataSelect);
            this.$emit("successFull",this.dataSelectFull);
        },
        table_passwd(row){
            this.$nextTick(() => {
                this.$refs.formMain.open("edit").setData(row)
            })
        },
        async table_del(row){
            var resp = await this.$API.factory.del.post({"id":row.id});
            if(resp.code == 0) {
                return this.$message.error(resp.msg)
            }
            this.$message.success(resp.msg);
            this.$refs.table.refresh()
        }
    }
}
</script>